#if 0

#define YARV_AOT_COMPILED 1

#include <ruby.h>
#include <node.h>
#include "yarvcore.h"
#include "vm.h"
#include "insnhelper.h"

#define INSN_ENTRY(x)
#define DEBUG_ENTER_INSN(x)
#define USAGE_ANALYSIS_INSN(x)
#define USAGE_ANALYSIS_OPERAND(x, y, z)
#define ADD_PC(x)
#define END_INSN()
#define SCREG(r) reg_##r

#define FIXNUM_2_P(a, b) ((a) & (b) & 1)
#define BASIC_OP_UNREDEFINED(op) (yarv_unredefined_flag)

#define GET_OPERAND(x) aot_insn_operands[x-1]
#define JUMP(lab) goto lab
#define CLEAR_ENV(x)

#ifndef HAVE_TYPE_ULONG
typedef unsigned long ulong;
#endif

extern int yarv_unredefined_flag;

VALUE compiled_func(){
  VALUE *reg_lfp;
  VALUE *reg_dfp;
  VALUE *reg_cfp;
  VALUE *reg_sp;
  VALUE *reg_pc;
  VALUE  throwed;
  
  struct thread_object *th;

#ifdef OPT_STACK_CACHING
  register VALUE reg_a, reg_b;
  reg_a = reg_b = 0;
#endif

  if(!IS_YARV_WORKING()){
    rb_bug("use compiled function with YARV");
  }
  
  GetThreadVal(yarv_get_current_running_thread() , th);
  reg_sp  = th->sp;
  reg_lfp = th->lfp;
  reg_dfp = th->dfp;
  reg_cfp = th->cfp;

//#define INSN_ENTRY(x) printf("insn: %s\n", #x);

#include "compiled.inc"
  
finish:
  return throwed;
}


void Init_compiled(){
  rb_define_global_function("compiled", compiled_func, 0);
}

#endif
